package test.testutil;

public class Car {
	
	private int id;
	private String name;
	
	//=====================================================
	
	//Convenience methods for testing
	
	public static Car[] newFour() {
		Car[] cars = new Car[4];
		cars[0] = Car.fromIdName(1, "Toyota-1");
		cars[1] = Car.fromIdName(2, "Honda-2");
		cars[2] = Car.fromIdName(3, "Charger-3");
		cars[3] = Car.fromIdName(4, "Dart-4");
		return cars;
	}
	
	/** Public constructor -- Returns new Employee given id and name */
	public static Car fromIdName(int id, String name) {
		return new Car(id, name);
	}
	
	private Car(int id, String name) {
		super();
		this.id = id;
		this.name = name;
	}	
		
	//=====================================================	

	public int getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	@Override
	public String toString() {
		return this.getName() + " (" + this.getId() + ")";
	}
	
	//=====================================================
	
	@Override	
	public int hashCode()  {
		int hashCode = 7;
		hashCode = 31 * hashCode + Integer.valueOf(this.id).hashCode();		
		hashCode = 31 * hashCode + (getName()!=null ? getName().hashCode() : 0);
		return hashCode;
	}	

	@Override
	public boolean equals(Object o) {
		if (o == this)
			return true;
		if (!(o instanceof Car))
			return false;
		Car other = (Car)o;
		return
			this.getId() == other.getId()
				&& safeEquals(this.getName(), other.getName());
	}
	
	public boolean safeEquals(Object a, Object b)  {
		//If only one is nil, then false, use XOR*/
		if (a==null ^ b==null)
			return false;
		//We now know both are null, or not null, check for condition #1 first*/
		//If either is null, they both are
		if (a==null)
			return true;
		//Finally a safe equals
		return a.equals(b);
	}		

	
	
	
}